package gcewing.prospecting;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid = Info.modID, name = Info.modName, version = Info.versionNumber)

@NetworkMod(clientSideRequired=true, serverSideRequired = true, versionBounds = Info.versionBounds,
	channels={"gce.prospecting"}, packetHandler = PacketHandler.class)

public class GregsProspecting extends BaseMod {
	
	public static GregsProspecting instance;
	
//	@SidedProxy(clientSide="gcewing.prospecting.ClientProxy", serverSide="gcewing.prospecting.CommonProxy")
//	public static CommonProxy proxy;
	
	public static ItemMiningRadar miningRadar, colorMiningRadar, industrialMiningRadar, industrialMiningRadarCharged;
	public static Item battery, mandrel, batteryCasing, carbonRod,
		electrolytePaste, bowlAppleJuice, carbonFilament, cathodeRayTube, magnetron,
		fibreglassBoard, microwaveHorn, brokenMiningRadar, slimophone, parabolicMicrophone,
		piezoTransducer, quartzWafer, triode, ledBarGraph, redPhosphor, greenPhosphor, bluePhosphor,
		colorCRT, colorMiningRadarCircuit;
	
	//static File cfgFile;
	//static Configuration config;
	//static OrderedProperties config;
	//static Map <Integer, String> idToName = new Hashtable <Integer, String>();
	
	public GregsProspecting() {
		super("gcewing." + Info.modPackage);
		instance = this;
	}
	
	@PreInit
	public void preInit(FMLPreInitializationEvent e) {
		//cfgFile = e.getSuggestedConfigurationFile();
		super.preInit(e);
	}
	
	@Init
	public void init(FMLInitializationEvent e) {
		super.init(e);
		//configure();
		//registerItems();
		//addRecipes();
		//proxy.registerKeys();		
		//proxy.registerRenderers();
	}
	
	@PostInit
	public void postInit(FMLPostInitializationEvent e) {
		//saveConfig();
		super.postInit(e);
	}
	
	BaseModClient initClient() {
		return new GregsProspectingClient(this);
	}

//	void loadConfig() {
//		config = new OrderedProperties();
//		try {
//			config.load(new FileInputStream(cfgFile));
//		}
//		catch (FileNotFoundException e) {
//			System.out.printf("GregsProspecting: No existing config file\n");
//		}
//		catch (IOException e) {
//			System.out.printf("GregsProspecting: Failed to read %s\n%s\n",
//				cfgFile.getPath(), e);
//		}
//		config.extended = false;
//	}

//	void saveConfig() {
//		try {
//			if (config.extended) {
//				System.out.printf("GregsProspecting: Writing config file\n");
//				config.store(new FileOutputStream(cfgFile),
//					"Greg's Prospecting Configuration File");
//				//System.out.printf("GregsProspecting: Written config file\n");
//			}
//		}
//		catch (IOException e) {
//			System.out.printf("GregsProspecting: Failed to %s\n%s\n",
//				cfgFile.getPath(), e);
//		}
//	}
	
//	static int getItemID(int defaultID, String name) {
//		int id = config.getInt(name, defaultID);
//		idToName.put(Integer.valueOf(256 + id), name);
//		return id;
//	}

	@Override
	void registerItems() {
//		miningRadar = new ItemMiningRadar(getItemID(3000, "miningRadar"), 17);
//		addItem("Mining Rader", miningRadar);
//		battery = addItem("Battery", newItemSI(3001, "battery", 6, 0));
//		mandrel = addItem("Wooden Mandrel", newItemI(3002, "mandrel", 24));
//		batteryCasing = addItem("Battery Casing", newItemI(3003, "batteryCasing", 1));
//		carbonRod = addItem("Carbon Rod", newItemI(3004, "carbonRod", 6));
//		electrolytePaste = addItem("Electrolyte Paste", newItemI(3005, "electrolytePaste", 11));
//		bowlAppleJuice = addItem("Apple Juice", newItemI(3006, "bowlAppleJuice", 3));
//		carbonFilament = addItem("Carbon Filament", newItemI(3007, "carbonFilament", 5));
//		cathodeRayTube = addItem("Cathode Ray Tube", newItemI(3008, "cathodeRayTube", 7));
//		magnetron = addItem("Magnetron", newItemI(3009, "magnetron", 15));
//		fibreglassBoard = addItem("Fibreglass Board", newItemI(3010, "fibreglassBoard", 12));

		miningRadar = newItem("miningRadar", ItemMiningRadar.class, "Mining Radar");
		battery = newItem("battery", "Battery");
		mandrel = newItem("mandrel", "Wooden Mandrel");
		mandrel.setContainerItem(mandrel);
		batteryCasing = newItem("batteryCasing", "Battery Casing");
		carbonRod = newItem("carbonRod", "Carbon Rod");
		electrolytePaste = newItem("electrolytePaste", "Electrolyte Paste");
		bowlAppleJuice = newItem("bowlAppleJuice", "Apple Juice");
		bowlAppleJuice.setContainerItem(Item.bowlEmpty);
		carbonFilament = newItem("carbonFilament", "Carbon Filament");
		cathodeRayTube = newItem("cathodeRayTube", "Cathode Ray Tube");
		magnetron = newItem("magnetron", "Magnetron");
		fibreglassBoard = newItem("fibreglassBoard", "Fibreglass Board");
		
//		microwaveHorn = addItem("Microwave Horn", newItemI(3011, "microwaveHorn", 16));
//		parabolicMicrophone = addItem("Parabolic Microphone", newItemI(3014, "parabolicMicrophone", 18));
//		piezoTransducer = addItem("Piezo Transducer", newItemI(3015, "piezoTransducer", 19));
//		quartzWafer = addItem("Quartz Wafer", newItemI(3016, "quartzWafer", 20));
//		triode = addItem("Triode", newItemI(3017, "triode", 23));
//		ledBarGraph = addItem("LED Bar Graph", newItemI(3018, "ledBarGraph", 14));
//		redPhosphor = addItem("Red Phosphor", newItemI(3020, "redPhosphor", 21));
//		greenPhosphor = addItem("Green Phosphor", newItemI(3021, "greenPhosphor", 13));
//		bluePhosphor = addItem("Blue Phosphor", newItemI(3022, "bluePhosphor", 2));
//		colorCRT = addItem("Colour CRT", newItemI(3023, "colorCRT", 8));
//		colorMiningRadarCircuit = addItem("Colour Mining Radar Circuit", newItemI(3024, "colorMiningRadarCircuit", 10));

		piezoTransducer = newItem("piezoTransducer", "Piezo Transducer");
		colorCRT = newItem("colorCRT", "Colour CRT");
		greenPhosphor = newItem("greenPhosphor", "Green Phosphor");
		ledBarGraph = newItem("ledBarGraph", "LED Bar Graph");
		microwaveHorn = newItem("microwaveHorn", "Microwave Horn");
		quartzWafer = newItem("quartzWafer", "Quartz Wafer");
		triode = newItem("triode", "Triode");
		redPhosphor = newItem("redPhosphor", "Red Phosphor");
		bluePhosphor = newItem("bluePhosphor", "Blue Phosphor");
		parabolicMicrophone = newItem("parabolicMicrophone", "Parabolic Microphone");
		colorMiningRadarCircuit = newItem("colorMiningRadarCircuit", "Colour Mining Radar Circuit");

//		brokenMiningRadar = new ItemMiningRadar(getItemID(3012, "brokenMiningRadar"), 4);
//		addItem("Broken Mining Radar", brokenMiningRadar);
//		slimophone = addItem("Slimophone", new ItemSlimophone(getItemID(3013, "slimophone")));
//		colorMiningRadar = new ItemMiningRadar(getItemID(3019, "colorMiningRadar"), 9);
//		addItem("Colour Mining Radar", colorMiningRadar);

		brokenMiningRadar = newItem("brokenMiningRadar", ItemMiningRadar.class, "Broken Mining Radar");		
		slimophone = newItem("slimophone", ItemSlimophone.class, "Slimophone");	
		colorMiningRadar = newItem("colorMiningRadar", ItemMiningRadar.class, "Colour Mining Radar");
	}
	
	void registerRecipes() {
		newShapelessRecipe(miningRadar, 1, new ItemStack(miningRadar, 1, -1), battery);
		newRecipe(mandrel, 1, "W", "W", "W", 'W', Block.planks);
		newShapelessRecipe(batteryCasing, 6, Item.ingotIron, mandrel);
		newRecipe(carbonRod, 6, "C", "C", "C", 'C', Item.coal);
		newShapelessRecipe(bowlAppleJuice, 1, Item.appleRed, Item.bowlEmpty);
		newShapelessRecipe(electrolytePaste, 6, bowlAppleJuice, new ItemStack(Item.dyePowder, 1, 15));
		newShapelessRecipe(battery, 1, batteryCasing, electrolytePaste, carbonRod);
		newSmeltingRecipe(carbonFilament, 1, Item.silk);
		newRecipe(cathodeRayTube, 1, "|gG", "|gf", "|gG",
			'|', Block.thinGlass, 'g', Item.lightStoneDust, 'G', Block.glass, 'f', carbonFilament);
		newRecipe(magnetron, 1, "rGr", "IGI", "rfr",
			'r', Item.redstone, 'G', Block.glass, 'I', Item.ingotIron, 'f', carbonFilament);
		newShapelessRecipe(fibreglassBoard, 1, Block.glass, Item.slimeBall);
		newRecipe(microwaveHorn, 1, "  I", "II ", "  I", 'I', Item.ingotIron);
		newRecipe(miningRadar, 1, "CMH", "LFB", "grg",
			'C', cathodeRayTube, 'M', magnetron, 'H', microwaveHorn, 'L', Block.lever, 'F', fibreglassBoard,
			'B', battery, 'g', Item.goldNugget, 'r', Item.redstone);
		newRecipe(slimophone, 1, "ltp", "grb", 'l', ledBarGraph, 't', triode, 'p', parabolicMicrophone,
			'g', Item.goldNugget, 'r', Item.redstone, 'b', battery);
		newRecipe(ledBarGraph, 1, "rgB", "rgB", "rgB",
			'r', Item.redstone, 'g', Item.lightStoneDust, 'B', new ItemStack(Block.cloth, 1, 15));
		newShapelessRecipe(slimophone, 1, new ItemStack(slimophone, 1, -1), battery);
		newRecipe(parabolicMicrophone, 1, " W", "Wp", " W", 'W', Block.planks, 'p', piezoTransducer);
		newRecipe(piezoTransducer, 1, "IqI", 'I', Item.ingotIron, 'q', quartzWafer);
		newSmeltingRecipe(quartzWafer, 1, Block.sandStone);
		newRecipe(triode, 1, " I ", "GrG", " f ", 
			'I', Item.ingotIron, 'G', Block.glass, 'r', Item.redstone, 'f', carbonFilament);
		newShapelessRecipe(redPhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 1));
		newShapelessRecipe(greenPhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 2));
		newShapelessRecipe(bluePhosphor, 1, Item.blazePowder, new ItemStack(Item.dyePowder, 1, 4));
		newRecipe(colorCRT, 1, "|rf", "|gf", "|bf",
			'|', Block.thinGlass, 'r', redPhosphor, 'g', greenPhosphor, 'b', bluePhosphor, 'f', carbonFilament);
		newRecipe(colorMiningRadarCircuit, 1, "rrr", " b ", " I ",
			'r', Item.redstone, 'b', fibreglassBoard, 'I', Item.ingotIron);
		newShapelessRecipe(colorMiningRadar, 1, miningRadar, colorCRT, colorMiningRadarCircuit);
		newRecipe(colorMiningRadar, 1, "CMH", "LFB", "grg",
			'C', colorCRT, 'M', magnetron, 'H', microwaveHorn, 'L', Block.lever, 'F', colorMiningRadarCircuit,
			'B', battery, 'g', Item.goldNugget, 'r', Item.redstone);
		newShapelessRecipe(colorMiningRadar, 1, new ItemStack(colorMiningRadar, 1, -1), battery);
	}
	
//	private void newRecipe(Item product, int qty, Object... params) {
//		GameRegistry.newRecipe(new ItemStack(product, qty), params);
//	}
//	
//	private void newShapelessRecipe(Item product, int qty, Object... params) {
//		GameRegistry.newShapelessRecipe(new ItemStack(product, qty), params);
//	}
//	
//	private void newSmeltingRecipe(Item product, int qty, Item input) {
//		GameRegistry.addSmelting(input.shiftedIndex, new ItemStack(product, qty), 0);
//	}
//	
//	private  void newSmeltingRecipe(Item product, int qty, Block input) {
//		GameRegistry.addSmelting(input.blockID, new ItemStack(product, qty), 0);
//	}
//	
//	private Item newItem(int id, String name) {
//		return new GregsItem(getItemID(id, name));
//	}
//	
//	private Item newItemI(int id, String name, int icon) {
//		return new GregsItem(getItemID(id, name)).setIconIndex(icon);
//	}
//	
//	private Item newItemSI(int id, String name, int maxStack, int icon) {
//		return new GregsItem(getItemID(id,name)).setMaxStackSize(maxStack).setIconIndex(icon);
//	}
//	
//	private Item addItem(String name, Item item) {
//		item.setItemName("gcewing." + idToName.get(item.shiftedIndex));
//		LanguageRegistry.addName(item, name);
//		return item;
//	}

}
